<!-- Parent component that contains all the components and functionalities needed to process the todolist -->
<template>
  <div>
    <b-row>
      <b-col style="margin-bottom: 20px">
        <!-- Component for creating a todolist -->
        <create-todo
          @createtodoevent="createTodo"
        />
      </b-col>
    </b-row>
    <b-card
      title="Gestion des tâches"
      header-tag="header"
      footer-tag="footer"
    >
      <!-- To display the different counters -->
      <template #header>
        <b-row>
          <b-col
            sm="12"
            md="9"
            lg="9"
            xl="9"
            offset-md="3"
            offset-lg="3"
            offset-xl="3"
          >
            <div class="position-count-li">
              <ul
                class="dashboard-info__list"
              >
                <!-- To display the total number of tasks -->
                <li-count
                  label="Nombre de tâche"
                  :count="data.job.total"
                />
                <!-- To display the total number of completed tasks -->
                <li-count
                  label="Tâches effectués"
                  :count="data.job.completed"
                  color="28a745"
                />
                <!-- To display the total number of uncompleted tasks -->
                <li-count
                  label="Tâches non effectués"
                  :count="uncompleted_tasks"
                  color="dc3545"
                />
              </ul>
            </div>
          </b-col>
        </b-row>
      </template>
      <b-card-text>
        <div>
          <b-row style="margin-bottom: 15px; margin-top: 15px">
            <b-col>
              Cliquer sur <i class="fas fa-times-circle text-danger" /> pour terminé une tâche, et sur <i class="fas fa-check-circle text-success" /> pour relancer la tâche.
            </b-col>
          </b-row>

          <!-- Component for displaying and processing data -->
          <data-table
            :items="data.todos"
            :fields="fields"
            :loading="data.loading"
            @updatedevent="updateTodo"
            @processdeleteevent="deleteTodo"
            @basculedevent="onBascule"
          />
          <!-- Component for different loading when retrieving or processing one or more data -->
          <overlay
            :loading="data.loading"
          />
        </div>
      </b-card-text>
      <template #footer>
        <div>
          © Olivier Nasolombolatiana RAJAONARIVO
        </div>
      </template>
    </b-card>
  </div>
</template>

<script>
import DataTable from './DataTable'
import Overlay from '../custom-components/Overlay'
import CreateTodo from './CreateTodo'
import LiCount from '../custom-components/LiCount'

export default {
  name: 'TodoContainer',
  components: {
    DataTable, Overlay, CreateTodo, LiCount
  },
  data () {
    return {
      // Gathers the different useful data during the treatment such as the number of tasks performed
      data: {
        todos: [],
        loading: false,
        job: {
          total: 0,
          completed: 0
        }
      },
      // List of fields in the table that displays the list of todolists
      fields: [
        { key: 'title', label: 'Titre' },
        { key: 'body', label: 'Description' },
        { key: 'completed', label: 'Tâche effectué' },
        'actions'
      ]
    }
  },
  computed: {
    /**
     * Returns the number of uncompleted tasks
     * @return {number}
     */
    uncompleted_tasks () {
      return this.data.job.total - this.data.job.completed
    }
  },
  mounted () {
    this.getDatas()
  },
  methods: {
    /**
     * Get 2 data from the free json placeholder API for init data
     * @return void
     */
    getDatas () {
      this.data.loading = true
      fetch('https://jsonplaceholder.typicode.com/posts?_limit=2&_start=0').then(response => response.json()).then((json) => {
        this.data.todos = json
        this.data.todos = this.data.todos.map(obj => ({ ...obj, completed: false }))
        this.data.job.total = this.data.todos.length
        this.data.loading = false
      }).catch((error) => {
        this.$bvToast.toast(`Error : ${error.message}`, {
          title: 'Error',
          variant: 'danger',
          solid: true,
          autoHideDelay: 2000,
          appendToast: true
        })
      })
    },
    /**
     * Action to create a task and insert it in the list
     * @param payload {Object}
     * @return void
     */
    createTodo (payload) {
      this.data.loading = true
      fetch('https://jsonplaceholder.typicode.com/posts', {
        method: 'POST',
        body: JSON.stringify({
          title: payload.title,
          body: payload.body,
          userId: 1
        }),
        headers: {
          'Content-type': 'application/json; charset=UTF-8'
        }
      })
        .then((response) => response.json())
        .then((json) => {
          const tmp = { ...json, completed: false }
          this.data.todos.unshift(tmp)
          this.data.job.total++
          this.data.loading = false
        })
    },
    /**
     * Function that allows a task to be switched to completed or uncompleted
     * @param payload {Object}
     */
    onBascule (payload) {
      const findIndex = this.data.todos.findIndex(el => el.id === payload.item.id)
      if (findIndex !== undefined) {
        this.data.todos[findIndex].completed = payload.value
        if (payload.value) {
          this.data.job.completed++
        } else {
          this.data.job.completed--
        }
      }
    },
    /**
     * Function to update a task in the task list
     * @param payload {Object}
     * @return void
     */
    updateTodo (payload) {
      const findIndex = this.data.todos.findIndex(el => el.id === payload.id)
      if (findIndex !== undefined) {
        this.data.todos[findIndex].body = payload.body
        this.data.todos[findIndex].title = payload.title
      }
    },
    /**
     * Function to execute the delete API and also delete the selected task from the task list
     * @param payload {Object}
     */
    deleteTodo (payload) {
      this.data.loading = true
      fetch(`https://jsonplaceholder.typicode.com/posts/${payload.id}`, {
        method: 'DELETE'
      }).then(response => response.json()).then((json) => {
        const findIndex = this.data.todos.findIndex(el => el.id === payload.id)
        if (findIndex !== undefined) {
          this.data.todos.splice(findIndex, 1)
          this.data.job.total--
          if (payload.completed) {
            this.data.job.completed--
          }
          this.data.loading = false
        }
      })
    }
  }
}
</script>

<style scoped>

</style>
